UNIT KeyHandler;

INTERFACE

VAR
   keys : Array[0..255] Of Boolean;

PROCEDURE Set_New_Int9; Far;
PROCEDURE Set_Old_Int9; Far;

CONST
   oldint9      : Pointer = Nil;
   e0flag       : Byte = 0;
   kSYSREQ      = $54;
   kCAPSLOCK    = $3A;
   kNUMLOCK     = $45;
   kSCROLLLOCK  = $46;
   kLEFTCTRL    = $1D;
   kLEFTALT     = $38;
   kLEFTSHIFT   = $2A;
   kRIGHTCTRL   = $9D;
   kRIGHTALT    = $B8;
   kRIGHTSHIFT  = $36;
   kESC         = $01;
   kBACKSPACE   = $0E;
   kENTER       = $1C;
   kSPACE       = $39;
   kTAB         = $0F;
   kF1          = $3B;
   kF2          = $3C;
   kF3          = $3D;
   kF4          = $3E;
   kF5          = $3F;
   kF6          = $40;
   kF7          = $41;
   kF8          = $42;
   kF9          = $43;
   kF10         = $44;
   kF11         = $57;
   kF12         = $58;
   kA           = $1E;
   kB           = $30;
   kC           = $2E;
   kD           = $20;
   kE           = $12;
   kF           = $21;
   kG           = $22;
   kH           = $23;
   kI           = $17;
   kJ           = $24;
   kK           = $25;
   kL           = $26;
   kM           = $32;
   kN           = $31;
   kO           = $18;
   kP           = $19;
   kQ           = $10;
   kR           = $13;
   kS           = $1F;
   kT           = $14;
   kU           = $16;
   kV           = $2F;
   kW           = $11;
   kX           = $2D;
   kY           = $15;
   kZ           = $2C;
   k1           = $02;
   k2           = $03;
   k3           = $04;
   k4           = $05;
   k5           = $06;
   k6           = $07;
   k7           = $08;
   k8           = $09;
   k9           = $0A;
   k0           = $0B;
   kMINUS       = $0C;
   kEQUAL       = $0D;
   kLBRACKET    = $1A;
   kRBRACKET    = $1B;
   kSEMICOLON   = $27;
   kTICK        = $28;
   kAPOSTROPHE  = $29;
   kBACKSLASH   = $2B;
   kCOMMA       = $33;
   kPERIOD      = $34;
   kSLASH       = $35;
   kINS         = $D2;
   kDEL         = $D3;
   kHOME        = $C7;
   kEND         = $CF;
   kPGUP        = $C9;
   kPGDN        = $D1;
   kLARROW      = $CB;
   kRARROW      = $CD;
   kUARROW      = $C8;
   kDARROW      = $D0;
   kKEYPAD0     = $52;
   kKEYPAD1     = $4F;
   kKEYPAD2     = $50;
   kKEYPAD3     = $51;
   kKEYPAD4     = $4B;
   kKEYPAD5     = $4C;
   kKEYPAD6     = $4D;
   kKEYPAD7     = $47;
   kKEYPAD8     = $48;
   kKEYPAD9     = $49;
   kKEYPADDEL   = $53;
   kKEYPADSTAR  = $37;
   kKEYPADMINUS = $4A;
   kKEYPADPLUS  = $4E;
   kKEYPADENTER = $9C;
   kCTRLPRTSC   = $B7;
   kSHIFTPRTSC  = $B7;
   kKEYPADSLASH = $B5;

IMPLEMENTATION

PROCEDURE New_Int9; Far; Forward;


PROCEDURE Set_New_Int9; Assembler;
ASM
   push    ds
   cli

   mov     ax, $3509                { get old INT 9 }
   int     $21
   mov     si, offset oldint9
   mov     [si], bx                { save offset }
   mov     [si + 2],es             { save segment }

   mov     ax, $2509               { set new INT 9 }
   mov     dx, seg New_Int9
   mov     ds, dx
   mov     dx, offset New_Int9
   int     $21

   sti
   pop     ds
End;

PROCEDURE Set_Old_Int9; Assembler;
ASM
   push    ds
   cli

   mov     ax, $2509                { set new INT 9 }
   mov     si, offset oldint9
   mov     dx, word ptr [si]        { load offset }
   mov     ds, word ptr [si + 2]    { load segment }
   int     $21

   sti
   pop     ds
End;

PROCEDURE New_Int9; Assembler;
ASM
   cli
   push    ds
   push    ax
   push    bx

   mov     ax, SEG @data
   mov     ds, ax

   in      ax,60h          {; Get SCAN CODE in AL, CONTROL in AH  }
   mov     bx,ax           {; Save a copy in BX                   }
   xchg    ah,al           {; Put CONTROL in AL                   }
   or      al,80h          {; Clear Keyboard of interrupt request }
   out     61h,al          {; :                                   }
   and     al,7Fh          {; : bit 7 = 0 -> ack kbd              }
   out     61h,al          {; :                                   }

   cmp     bl,0E0h         { was it an E0 key?                    }
   jne    @setscancode

{ E0 key routine }
   mov     [e0flag],128
   mov     al,20h          { Send generic EOI to PIC               }
   out     20h,al          { 001 00 000                            }
                           {  |   |  |                             }
                           {  |   |  +--- INT request level        }
                           {  |   +------ OCW2                     }
                           {  +---------- non-specific EOI command }
   pop     bx
   pop     ax
   pop     ds
   sti
   iret

@setscancode:
   mov     al,bl                   { save scan code }
   and     bl,01111111b
   add     bl,[e0flag]
   xor     bh,bh                   { clear for index use }
   and     al,10000000b            { keep break bit, if set }
   xor     al,10000000b            { flip bit - 1 means pressed  }
                                   {          - 0 means released }
   rol     al,1                    { put it in bit 0 }
   mov     [offset keys + bx],al   { set index for key }
   mov     [e0flag],0

   mov     al,20h          { Send generic EOI to PIC               }
   out     20h,al          { 001 00 000                            }
                           {  |   |  |                             }
                           {  |   |  +--- INT request level        }
                           {  |   +------ OCW2                     }
                           {  +---------- non-specific EOI command }
   pop     bx
   pop     ax
   pop     ds
   sti
   iret
End;

Begin
End.
